namespace PkmnLib.Plugin.Gen7.Scripts.Abilities;

/// <summary>
/// Quick Feet is an ability that boosts Speed when the Pokémon has a status condition.
///
/// <see href="https://bulbapedia.bulbagarden.net/wiki/Quick_Feet_(Ability)">Bulbapedia - Quick Feet</see>
/// </summary>
[Script(ScriptCategory.Ability, "quick_feet")]
public class QuickFeet : Script, IScriptChangeSpeed
{
    /// <inheritdoc />
    public void ChangeSpeed(ITurnChoice choice, ref uint speed)
    {
        if (choice.User.StatusScript.IsEmpty)
            return;
        if (choice.User.StatusScript.Script?.Name == "paralyzed")
            speed = speed.MultiplyOrMax(2);
        speed = speed.MultiplyOrMax(1.5f);
    }
}